hat = require 'hat'
cookie = require 'cookie'

store = require './store'

makeId = -> hat 128*4
isFunction = (obj) -> '[object Function]' is toString.call obj

module.exports = (store = module.exports.store.memory(), key = 'sid', o = {}) -> (req, res, next) ->
    throw new Error 'no cookies' unless req?.cookies?
    opts = o
    opts.path = '/' unless opts.path?
    opts.expires = opts.expires() if isFunction opts.expires
    req.cookies[key] ?= makeId()
    id = req.cookies[key]
    res.setHeader 'Set-Cookie', [cookie.serialize key, id, opts]

    origEnd = res.end
    res.end = (data, encoding) ->
        res.end = origEnd
        store.set id, req.session, ->
            res.end data, encoding

    store.get id, (err, session) ->
        throw new Error err if err?
        req.session = session
        next()

    # run cleanup

    # each 10k requests we make a database cleanup to delete old entries
    if Math.random() <= 0.001
        console.info 'run session cleanup'
        dayDuration = 1000 * 60 * 60 * 24
        days = 7
        today = new Date()
        date = new Date(+new Date - days * dayDuration)
        store.deleteOlderThen date, (err) ->
            return console.err err if err?
            console.info 'session cleanup finished'

module.exports.store = store
