mesa = require 'mesa'

module.exports = (getConnection, table = 'session') ->

    model = new mesa()
        .table(table)
        .connection(getConnection)
        .attributes(['id', 'session', 'created', 'modified'])

    get: (id, cb) ->
        model.where(id: id).first (err, result) ->
            return cb err if err?
            return cb null, {} unless result?
            parsed = JSON.parse result.session
            cb null, parsed

    set: (id, session, cb) ->
        return cb err if err?
        stringified = JSON.stringify session
        model.where(id: id).update {session: stringified, modified: new Date()}, (err) ->
            return cb err if err?
            getConnection (err, connection) ->
                return cb err if err?
                sql = 'INSERT INTO session (id, session) SELECT $1, $2 WHERE NOT EXISTS (SELECT 1 FROM session WHERE id=$1);'
                params = [id, stringified]
                connection.query sql, params, cb

    deleteOlderThen: (date, cb) ->
        model.where(modified: $lt: date).delete cb
