#!/usr/bin/env coffee

fs = require 'fs'

mysql = require 'mysql'

createTable = fs.readFileSync './asset/session.sql', 'utf-8'

Store = require './lib/store/mysql'

mysqlHost = 'localhost'
mysqlUser = 'root'
mysqlPassword = ''
mysqlDatabase = 'mysql_store_test'

setupDatabase = (connection) ->
    connection.query "DROP DATABASE IF EXISTS #{mysqlDatabase}"
    connection.query "CREATE DATABASE #{mysqlDatabase}"
    connection.query "USE #{mysqlDatabase}"
    connection.query createTable

teardownDatabase = (connection) ->
    connection.query "DROP DATABASE #{mysqlDatabase}"
    connection.end()

getConnection = ->
    mysql.createConnection
        host: mysqlHost
        user: mysqlUser
        password: mysqlPassword
        multipleStatements: true

# connection = getConnection()
# setupDatabase connection
# teardownDatabase connection

# code comes here

module.exports =
    setUp: (next) ->
        @connection = getConnection()
        setupDatabase @connection
        @store = Store @connection
        next()

    tearDown: (next) ->
        teardownDatabase @connection
        next()

    'retrieve empty values if id does not exist': (test) ->
        @store.get 'does not exist', (err, result) ->
            test.deepEqual {}, result
            test.done()

    'set and get values': (test) ->
        store = @store
        store.set 'id', {foo: 'bar'}, (err) ->
            test.ifError err
            store.get 'id', (err, result) ->
                test.ifError err
                test.equal 'bar', result.foo
                test.done()

    'update works': (test) ->
        store = @store
        store.set 'foo', {x: 1}, (err) ->
            test.ifError err
            store.set 'foo', {x: 2}, (err) ->
                test.ifError err
                store.get 'foo', (err, result) ->
                    test.ifError err
                    test.equal 2, result.x
                    test.done()
