exec = require '../../src/exec'

module.exports =
    'simple': (test) ->
        f = -> test.done()
        exec(f) {}, {}, ->
    'is continuing': (test) ->
        f = (req, next) -> next()
        exec(f) {}, {}, -> test.done()
    'error handling': (test) ->
        f = (req, next) -> next 'ERROR'
        res =
            writeHead: (status) -> test.equals 500, status
            end: -> test.done()
        exec(f) {}, res, ->

    'can have custom error method': (test) ->
        exec.errorCallback = (req, res, err, name) ->
            test.equal err, 'error'
            test.equal name, 'exec'
            test.done()
        middleware = exec (req, cb) -> cb 'error'
        middleware {}, {}

